/*
 * http_err.c:
 * This file is automatically generated; please do not edit it.
 */

#include <stdlib.h>

#define N_(a) a

static const char * const text[] = {
	N_(   "100 Continue"),
	N_(   "101 Switching Protocols"),
	N_(   "102 Processing"                      /* RFC 2518 (WebDAV) */),
	N_(   "103 Early Hints"                     /* RFC 8297 (Indicating Hints) */),
	N_(   "200 OK"),
	N_(   "201 Created"),
	N_(   "202 Accepted"),
	N_(   "204 No Content"),
	N_(   "205 Reset Content"),
	N_(   "206 Partial Content"),
	N_(   "207 Multi-Status"                    /* RFC 4918 (WebDAV) */),
	N_(   "301 Moved Permanently"),
	N_(   "302 Found"),
	N_(   "304 Not Modified"),
	N_(   "400 Bad Request"),
	N_(   "401 Unauthorized"),
	N_(   "403 Forbidden"),
	N_(   "404 Not Found"),
	N_(   "405 Method Not Allowed"),
	N_(   "406 Not Acceptable"),
	N_(   "408 Request Timeout"),
	N_(   "409 Conflict"),
	N_(   "410 Gone"),
	N_(   "411 Length Required"),
	N_(   "412 Precondition Failed"),
	N_(   "413 Payload Too Large"),
	N_(   "414 URI Too Long"),
	N_(   "415 Unsupported Media Type"),
	N_(   "415 Unsupported Media Type"          /* RFC 7694 (Client-Initiated C-E) */),
	N_(   "416 Range Not Satisfiable"),
	N_(   "417 Expectation Failed"),
	N_(   "421 Misdirected Request"),
	N_(   "422 Unprocessable Entity"),
	N_(   "423 Locked"                          /* RFC 4918 (WebDAV) */),
	N_(   "424 Failed Dependency"               /* RFC 4918 (WebDAV) */),
	N_(   "426 Upgrade Required"),
	N_(   "500 Internal Server Error"),
	N_(   "501 Not Implemented"),
	N_(   "502 Bad Gateway"),
	N_(   "503 Service Unavailable"),
	N_(   "503 Service Unavailable"             /* Shutdown file vs other issues */),
	N_(   "505 HTTP Version Not Supported"),
	N_(   "507 Insufficient Storage"            /* RFC 4918 (WebDAV) */),
    0
};

struct error_table {
    char const * const * msgs;
    long base;
    int n_msgs;
};
struct et_list {
    struct et_list *next;
    const struct error_table * table;
};
extern struct et_list *_et_list;

const struct error_table et_http_error_table = { text, -1964267008L, 43 };

static struct et_list link = { 0, 0 };

void initialize_http_error_table_r(struct et_list **list);
void initialize_http_error_table(void);

void initialize_http_error_table(void) {
    initialize_http_error_table_r(&_et_list);
}

/* For Heimdal compatibility */
void initialize_http_error_table_r(struct et_list **list)
{
    struct et_list *et, **end;

    for (end = list, et = *list; et; end = &et->next, et = et->next)
        if (et->table->msgs == text)
            return;
    et = malloc(sizeof(struct et_list));
    if (et == 0) {
        if (!link.table)
            et = &link;
        else
            return;
    }
    et->table = &et_http_error_table;
    et->next = 0;
    *end = et;
}
