#ifndef INCLUDE_PROMDATA_H
#define INCLUDE_PROMDATA_H
/* generated from imap/promdata.p */

#include <sys/types.h>

#include <stdint.h>

enum prom_metric_type {
    PROM_METRIC_COUNTER   = 0,
    PROM_METRIC_GAUGE     = 1,
    PROM_METRIC_HISTOGRAM = 2, /* unused */
    PROM_METRIC_SUMMARY   = 3, /* unused */
    PROM_METRIC_CONTINUED = 4, /* internal use only */
};
extern const char *prom_metric_type_names[];

enum prom_metric_id {
    CYRUS_IMAP_CONNECTIONS_TOTAL = 0,
    CYRUS_IMAP_ACTIVE_CONNECTIONS,
    CYRUS_IMAP_READY_LISTENERS,
    CYRUS_IMAP_SHUTDOWN_TOTAL_STATUS_OK,
    CYRUS_IMAP_SHUTDOWN_TOTAL_STATUS_ERROR,
    CYRUS_IMAP_APPEND_TOTAL,
    CYRUS_IMAP_AUTHENTICATE_TOTAL_RESULT_YES,
    CYRUS_IMAP_AUTHENTICATE_TOTAL_RESULT_NO,
    CYRUS_IMAP_CAPABILITY_TOTAL,
    CYRUS_IMAP_COMPRESS_TOTAL,
    CYRUS_IMAP_CHECK_TOTAL,
    CYRUS_IMAP_COPY_TOTAL,
    CYRUS_IMAP_CREATE_TOTAL,
    CYRUS_IMAP_CLOSE_TOTAL,
    CYRUS_IMAP_DELETE_TOTAL,
    CYRUS_IMAP_DELETEACL_TOTAL,
    CYRUS_IMAP_DUMP_TOTAL,
    CYRUS_IMAP_EXPUNGE_TOTAL,
    CYRUS_IMAP_EXAMINE_TOTAL,
    CYRUS_IMAP_FETCH_TOTAL,
    CYRUS_IMAP_GETACL_TOTAL,
    CYRUS_IMAP_GETANNOTATION_TOTAL,
    CYRUS_IMAP_GETMETADATA_TOTAL,
    CYRUS_IMAP_GETQUOTA_TOTAL,
    CYRUS_IMAP_GETQUOTAROOT_TOTAL,
    CYRUS_IMAP_GENURLAUTH_TOTAL,
    CYRUS_IMAP_ID_TOTAL,
    CYRUS_IMAP_IDLE_TOTAL,
    CYRUS_IMAP_LOGOUT_TOTAL,
    CYRUS_IMAP_LIST_TOTAL,
    CYRUS_IMAP_LSUB_TOTAL,
    CYRUS_IMAP_LISTRIGHTS_TOTAL,
    CYRUS_IMAP_MYRIGHTS_TOTAL,
    CYRUS_IMAP_MUPDATEPUSH_TOTAL,
    CYRUS_IMAP_STARTTLS_TOTAL,
    CYRUS_IMAP_STORE_TOTAL,
    CYRUS_IMAP_SELECT_TOTAL,
    CYRUS_IMAP_SEARCH_TOTAL,
    CYRUS_IMAP_ESEARCH_TOTAL,
    CYRUS_IMAP_SUBSCRIBE_TOTAL,
    CYRUS_IMAP_SETACL_TOTAL,
    CYRUS_IMAP_SETANNOTATION_TOTAL,
    CYRUS_IMAP_SETMETADATA_TOTAL,
    CYRUS_IMAP_SETQUOTA_TOTAL,
    CYRUS_IMAP_SORT_TOTAL,
    CYRUS_IMAP_STATUS_TOTAL,
    CYRUS_IMAP_SCAN_TOTAL,
    CYRUS_IMAP_THREAD_TOTAL,
    CYRUS_IMAP_UNAUTHENTICATE_TOTAL,
    CYRUS_IMAP_UNSUBSCRIBE_TOTAL,
    CYRUS_IMAP_UNSELECT_TOTAL,
    CYRUS_IMAP_XBACKUP_TOTAL,
    CYRUS_LMTP_CONNECTIONS_TOTAL,
    CYRUS_LMTP_ACTIVE_CONNECTIONS,
    CYRUS_LMTP_READY_LISTENERS,
    CYRUS_LMTP_SHUTDOWN_TOTAL_STATUS_OK,
    CYRUS_LMTP_SHUTDOWN_TOTAL_STATUS_ERROR,
    CYRUS_LMTP_AUTHENTICATE_TOTAL_RESULT_YES,
    CYRUS_LMTP_AUTHENTICATE_TOTAL_RESULT_NO,
    CYRUS_LMTP_RECEIVED_MESSAGES_TOTAL,
    CYRUS_LMTP_RECEIVED_BYTES_TOTAL,
    CYRUS_LMTP_RECEIVED_RECIPIENTS_TOTAL,
    CYRUS_LMTP_TRANSMITTED_MESSAGES_TOTAL,
    CYRUS_LMTP_TRANSMITTED_BYTES_TOTAL,
    CYRUS_LMTP_SIEVE_REDIRECT_TOTAL,
    CYRUS_LMTP_SIEVE_DISCARD_TOTAL,
    CYRUS_LMTP_SIEVE_REJECT_TOTAL,
    CYRUS_LMTP_SIEVE_FILEINTO_TOTAL,
    CYRUS_LMTP_SIEVE_SNOOZE_TOTAL,
    CYRUS_LMTP_SIEVE_KEEP_TOTAL,
    CYRUS_LMTP_SIEVE_NOTIFY_TOTAL,
    CYRUS_LMTP_SIEVE_IMIP_TOTAL,
    CYRUS_LMTP_SIEVE_AUTORESPOND_TOTAL,
    CYRUS_LMTP_SIEVE_AUTORESPOND_SENT_TOTAL,
    CYRUS_HTTP_CONNECTIONS_TOTAL,
    CYRUS_HTTP_ACTIVE_CONNECTIONS,
    CYRUS_HTTP_READY_LISTENERS,
    CYRUS_HTTP_SHUTDOWN_TOTAL_STATUS_OK,
    CYRUS_HTTP_SHUTDOWN_TOTAL_STATUS_ERROR,
    CYRUS_HTTP_ACL_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_ACL_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_ACL_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_ACL_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_ACL_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_ACL_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_ACL_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_ACL_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_ACL_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_ACL_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_ACL_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_ACL_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_ACL_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_ACL_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_ACL_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_ACL_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_ACL_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_BIND_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_BIND_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_BIND_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_BIND_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_BIND_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_BIND_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_BIND_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_BIND_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_BIND_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_BIND_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_BIND_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_BIND_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_BIND_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_BIND_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_BIND_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_BIND_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_BIND_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_CONNECT_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_CONNECT_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_CONNECT_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_CONNECT_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_CONNECT_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_CONNECT_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_CONNECT_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_CONNECT_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_CONNECT_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_CONNECT_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_CONNECT_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_CONNECT_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_CONNECT_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_CONNECT_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_CONNECT_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_CONNECT_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_CONNECT_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_COPY_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_COPY_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_COPY_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_COPY_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_COPY_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_COPY_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_COPY_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_COPY_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_COPY_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_COPY_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_COPY_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_COPY_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_COPY_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_COPY_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_COPY_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_COPY_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_COPY_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_DELETE_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_DELETE_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_DELETE_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_DELETE_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_DELETE_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_DELETE_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_DELETE_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_DELETE_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_DELETE_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_DELETE_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_DELETE_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_DELETE_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_DELETE_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_DELETE_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_DELETE_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_DELETE_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_DELETE_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_GET_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_GET_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_GET_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_GET_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_GET_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_GET_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_GET_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_GET_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_GET_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_GET_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_GET_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_GET_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_GET_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_GET_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_GET_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_GET_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_GET_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_HEAD_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_HEAD_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_HEAD_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_HEAD_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_HEAD_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_HEAD_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_HEAD_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_HEAD_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_HEAD_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_HEAD_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_HEAD_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_HEAD_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_HEAD_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_HEAD_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_HEAD_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_HEAD_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_HEAD_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_LOCK_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_LOCK_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_LOCK_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_LOCK_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_LOCK_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_LOCK_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_LOCK_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_LOCK_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_LOCK_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_LOCK_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_LOCK_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_LOCK_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_LOCK_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_LOCK_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_LOCK_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_LOCK_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_LOCK_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_MKCALENDAR_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_MKCALENDAR_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_MKCALENDAR_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_MKCALENDAR_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_MKCALENDAR_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_MKCALENDAR_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_MKCALENDAR_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_MKCALENDAR_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_MKCALENDAR_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_MKCALENDAR_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_MKCALENDAR_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_MKCALENDAR_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_MKCALENDAR_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_MKCALENDAR_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_MKCALENDAR_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_MKCALENDAR_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_MKCALENDAR_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_MKCOL_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_MKCOL_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_MKCOL_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_MKCOL_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_MKCOL_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_MKCOL_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_MKCOL_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_MKCOL_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_MKCOL_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_MKCOL_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_MKCOL_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_MKCOL_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_MKCOL_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_MKCOL_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_MKCOL_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_MKCOL_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_MKCOL_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_MOVE_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_MOVE_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_MOVE_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_MOVE_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_MOVE_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_MOVE_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_MOVE_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_MOVE_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_MOVE_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_MOVE_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_MOVE_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_MOVE_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_MOVE_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_MOVE_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_MOVE_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_MOVE_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_MOVE_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_OPTIONS_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_OPTIONS_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_OPTIONS_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_OPTIONS_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_OPTIONS_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_OPTIONS_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_OPTIONS_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_OPTIONS_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_OPTIONS_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_OPTIONS_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_OPTIONS_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_OPTIONS_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_OPTIONS_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_OPTIONS_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_OPTIONS_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_OPTIONS_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_OPTIONS_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_PATCH_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_PATCH_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_PATCH_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_PATCH_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_PATCH_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_PATCH_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_PATCH_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_PATCH_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_PATCH_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_PATCH_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_PATCH_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_PATCH_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_PATCH_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_PATCH_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_PATCH_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_PATCH_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_PATCH_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_POST_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_POST_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_POST_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_POST_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_POST_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_POST_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_POST_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_POST_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_POST_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_POST_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_POST_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_POST_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_POST_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_POST_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_POST_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_POST_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_POST_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_PROPFIND_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_PROPFIND_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_PROPFIND_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_PROPFIND_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_PROPFIND_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_PROPFIND_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_PROPFIND_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_PROPFIND_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_PROPFIND_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_PROPFIND_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_PROPFIND_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_PROPFIND_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_PROPFIND_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_PROPFIND_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_PROPFIND_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_PROPFIND_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_PROPFIND_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_PROPPATCH_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_PROPPATCH_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_PROPPATCH_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_PROPPATCH_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_PROPPATCH_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_PROPPATCH_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_PROPPATCH_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_PROPPATCH_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_PROPPATCH_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_PROPPATCH_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_PROPPATCH_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_PROPPATCH_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_PROPPATCH_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_PROPPATCH_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_PROPPATCH_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_PROPPATCH_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_PROPPATCH_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_PUT_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_PUT_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_PUT_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_PUT_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_PUT_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_PUT_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_PUT_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_PUT_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_PUT_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_PUT_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_PUT_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_PUT_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_PUT_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_PUT_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_PUT_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_PUT_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_PUT_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_REPORT_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_REPORT_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_REPORT_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_REPORT_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_REPORT_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_REPORT_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_REPORT_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_REPORT_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_REPORT_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_REPORT_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_REPORT_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_REPORT_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_REPORT_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_REPORT_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_REPORT_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_REPORT_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_REPORT_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_SEARCH_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_SEARCH_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_SEARCH_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_SEARCH_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_SEARCH_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_SEARCH_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_SEARCH_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_SEARCH_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_SEARCH_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_SEARCH_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_SEARCH_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_SEARCH_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_SEARCH_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_SEARCH_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_SEARCH_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_SEARCH_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_SEARCH_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_TRACE_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_TRACE_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_TRACE_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_TRACE_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_TRACE_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_TRACE_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_TRACE_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_TRACE_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_TRACE_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_TRACE_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_TRACE_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_TRACE_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_TRACE_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_TRACE_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_TRACE_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_TRACE_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_TRACE_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_UNBIND_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_UNBIND_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_UNBIND_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_UNBIND_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_UNBIND_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_UNBIND_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_UNBIND_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_UNBIND_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_UNBIND_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_UNBIND_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_UNBIND_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_UNBIND_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_UNBIND_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_UNBIND_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_UNBIND_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_UNBIND_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_UNBIND_TOTAL_NAMESPACE_CGI,
    CYRUS_HTTP_UNLOCK_TOTAL_NAMESPACE_DEFAULT,
    CYRUS_HTTP_UNLOCK_TOTAL_NAMESPACE_ADMIN,
    CYRUS_HTTP_UNLOCK_TOTAL_NAMESPACE_APPLEPUSH,
    CYRUS_HTTP_UNLOCK_TOTAL_NAMESPACE_CALENDAR,
    CYRUS_HTTP_UNLOCK_TOTAL_NAMESPACE_FREEBUSY,
    CYRUS_HTTP_UNLOCK_TOTAL_NAMESPACE_ADDRESSBOOK,
    CYRUS_HTTP_UNLOCK_TOTAL_NAMESPACE_PRINCIPAL,
    CYRUS_HTTP_UNLOCK_TOTAL_NAMESPACE_NOTIFY,
    CYRUS_HTTP_UNLOCK_TOTAL_NAMESPACE_DBLOOKUP,
    CYRUS_HTTP_UNLOCK_TOTAL_NAMESPACE_ISCHEDULE,
    CYRUS_HTTP_UNLOCK_TOTAL_NAMESPACE_DOMAINKEYS,
    CYRUS_HTTP_UNLOCK_TOTAL_NAMESPACE_JMAP,
    CYRUS_HTTP_UNLOCK_TOTAL_NAMESPACE_PROMETHEUS,
    CYRUS_HTTP_UNLOCK_TOTAL_NAMESPACE_RSS,
    CYRUS_HTTP_UNLOCK_TOTAL_NAMESPACE_TZDIST,
    CYRUS_HTTP_UNLOCK_TOTAL_NAMESPACE_DRIVE,
    CYRUS_HTTP_UNLOCK_TOTAL_NAMESPACE_CGI,

    PROM_NUM_METRICS /* n.b. leave last! */
};

enum prom_labelled_metric {
    CYRUS_IMAP_SHUTDOWN_TOTAL = 0,
    CYRUS_IMAP_AUTHENTICATE_TOTAL,
    CYRUS_LMTP_SHUTDOWN_TOTAL,
    CYRUS_LMTP_AUTHENTICATE_TOTAL,
    CYRUS_HTTP_SHUTDOWN_TOTAL,
    CYRUS_HTTP_ACL_TOTAL,
    CYRUS_HTTP_BIND_TOTAL,
    CYRUS_HTTP_CONNECT_TOTAL,
    CYRUS_HTTP_COPY_TOTAL,
    CYRUS_HTTP_DELETE_TOTAL,
    CYRUS_HTTP_GET_TOTAL,
    CYRUS_HTTP_HEAD_TOTAL,
    CYRUS_HTTP_LOCK_TOTAL,
    CYRUS_HTTP_MKCALENDAR_TOTAL,
    CYRUS_HTTP_MKCOL_TOTAL,
    CYRUS_HTTP_MOVE_TOTAL,
    CYRUS_HTTP_OPTIONS_TOTAL,
    CYRUS_HTTP_PATCH_TOTAL,
    CYRUS_HTTP_POST_TOTAL,
    CYRUS_HTTP_PROPFIND_TOTAL,
    CYRUS_HTTP_PROPPATCH_TOTAL,
    CYRUS_HTTP_PUT_TOTAL,
    CYRUS_HTTP_REPORT_TOTAL,
    CYRUS_HTTP_SEARCH_TOTAL,
    CYRUS_HTTP_TRACE_TOTAL,
    CYRUS_HTTP_UNBIND_TOTAL,
    CYRUS_HTTP_UNLOCK_TOTAL,

    PROM_NUM_LABELLED_METRICS /* n.b. leave last! */
};

struct prom_label_lookup_value {
    const char *value;
    enum prom_metric_id id;
};

extern const struct prom_label_lookup_value *prom_label_lookup_table[];


struct prom_metric_desc {
    const char *name;
    enum prom_metric_type type;
    const char *help;
    const char *label;
};
extern const struct prom_metric_desc prom_metric_descs[];

struct prom_metric {
    double value;
    int64_t last_updated;
};

struct prom_stats {
    char  ident[512];   /* XXX places upper limit on service names */
    struct prom_metric metrics[PROM_NUM_METRICS];
};
#define PROM_STATS_INITIALIZER { {0}, {{0, 0}} }

#endif
